OpenTTD Source: DepotWindow Struct Reference

OpenTTD Source 15.3

Data Structures | Public Types | Public Member Functions | Data Fields
DepotWindow Struct Reference
Inheritance diagram for DepotWindow:

## Data Structures
struct | GetDepotVehiclePtData

## Public Types
enum | DepotGUIAction : uint8_t { MODE_ERROR , MODE_DRAG_VEHICLE , MODE_SHOW_VEHICLE , MODE_START_STOP }
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.

## Public Member Functions
| DepotWindow (WindowDesc &desc, TileIndex tile, VehicleType type)
void | Close (int data=0) override
| Hide the window and all its child windows, and mark them for a later deletion.
uint | CountDraggedLength (const Train *t) const
| Count the dragged selection length if appropriate for the provided train.
void | DrawVehicleInDepot (const Vehicle *v, const Rect &r) const
| Draw a vehicle in the depot window in the box with the top left corner at x,y.
void | DrawWidget (const Rect &r, WidgetID widget) const override
| Draw the contents of a nested widget.
std::string | GetWidgetString (WidgetID widget, StringID stringid) const override
| Get the raw string for a widget.
DepotGUIAction | GetVehicleFromDepotWndPt (int x, int y, const Vehicle **veh, GetDepotVehiclePtData *d)
void | DepotClick (int x, int y)
| Handle click in the depot matrix.
void | SetupWidgetData (VehicleType type)
| Function to set up vehicle specific widgets (mainly sprites and strings).
void | OnInit () override
| Notification that the nested widget tree gets initialized.
void | UpdateWidgetSize (WidgetID widget, Dimension &size, const Dimension &padding, Dimension &fill, Dimension &resize) override
| Update size and resize step of a widget in the window.
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid.
void | RefreshVehicleList ()
void | OnPaint () override
| The window must be repainted.
void | OnClick (Point pt, WidgetID widget, int click_count) override
| A click with the left mouse button has been made on the window.
void | OnQueryTextFinished (std::optional< std::string > str) override
| The query window opened from this window has closed.
bool | OnRightClick (Point pt, WidgetID widget) override
| A click with the right mouse button has been made on the window.
bool | OnVehicleSelect (const Vehicle *v) override
| Clones a vehicle.
bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end) override
| Clones a vehicle from a vehicle list.
void | OnPlaceObjectAbort () override
| The user cancelled a tile highlight mode that has been set.
void | OnMouseLoop () override
| Called for every mouse loop run, which is at least once per (game) tick.
void | OnMouseDrag (Point pt, WidgetID widget) override
| An 'object' is being dragged at the provided position, highlight the target if possible.
void | OnDragDrop (Point pt, WidgetID widget) override
| A dragged 'object' has been released.
void | OnTimeout () override
| Called when this window's timeout has been reached.
void | OnResize () override
| Called after the window got resized.
EventState | OnCTRLStateChange () override
| The state of the control key has changed.
DestinationID | GetDestinationIndex () const
| Gets the DepotID of the current window.
Public Member Functions inherited from Window
| Window (WindowDesc &desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree.
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox.
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (size_t from, size_t to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled.
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered.
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised.
void | RaiseWidgetWhenLowered (WidgetID widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered.
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (WidgetID wid, std::string_view str, bool marked, std::optional< size_t > caret, std::optional< size_t > insert_location, std::optional< size_t > replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets.
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets.
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered.
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
Window * | FindChildWindow (WindowClass wc=WC_INVALID) const
| Find the Window whose parent pointer points to this window.
Window * | FindChildWindowById (WindowClass wc, WindowNumber number) const
| Find the Window whose parent pointer points to this window.
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner.
void | CloseChildWindowById (WindowClass wc, WindowNumber number) const
| Close all children a window might have in a head-recursive manner.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnFocus ()
| The window has gained focus.
virtual void | OnFocusLost (bool closing)
| The window has lost focus.
virtual EventState | OnKeyPress (char32_t key, uint16_t keycode)
| A key has been pressed.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual void | OnHover (Point pt, WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it.
virtual bool | OnTooltip (Point pt, WidgetID widget, TooltipCloseCondition close_cond)
| Event to display a custom tooltip.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnScrollbarScroll (WidgetID widget)
| Notify window that a scrollbar position has been updated.
virtual void | OnMouseOver (Point pt, WidgetID widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel, WidgetID widget)
| The mouse wheel has been turned.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnDropdownSelect (WidgetID widget, int index, int click_result)
| A dropdown option associated to this window has been selected.
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, int click_result, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnEditboxChanged (WidgetID widget)
| The text in an editbox has been edited.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.

## Data Fields
VehicleID | sel = VehicleID::Invalid()
VehicleID | vehicle_over = VehicleID::Invalid()
| Rail vehicle over which another one is dragged, `VehicleID::Invalid()` if none.
VehicleType | type = VEH_INVALID
bool | generate_list = true
bool | check_unitnumber_digits = true
WidgetID | hovered_widget = INVALID_WIDGET
| Index of the widget being hovered during drag/drop. `INVALID_WIDGET` if no drag is in progress.
VehicleList | vehicle_list {}
VehicleList | wagon_list {}
uint | unitnumber_digits = 2
uint | num_columns = 1
| Number of columns.
Scrollbar * | hscroll = nullptr
| Only for trains.
Scrollbar * | vscroll = nullptr
uint | count_width = 0
| Width of length count, including separator.
uint | header_width = 0
| Width of unit number and flag, including separator.
Dimension | flag_size {}
| Size of start/stop flag.
VehicleCellSize | cell_size {}
| Vehicle sprite cell size.
bool | last_overlay_state = false
Data Fields inherited from Window
WindowDesc & | window_desc
| Window description.
WindowFlags | flags {}
| Window flags.
WindowClass | window_class {}
| Window class.
WindowNumber | window_number = 0
| Window number within the window class.
int | scale = 0
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer = 0
| Timer value of the WindowFlag::Timeout for flags.
uint8_t | white_border_timer = 0
| Timer value of the WindowFlag::WhiteBorder for flags.
int | left = 0
| x position of left edge of the window
int | top = 0
| y position of top edge of the window
int | width = 0
| width of the window (number of pixels to the right in x direction)
int | height = 0
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize {}
| Resize information.
Owner | owner = INVALID_OWNER
| The owner of the content shown in this window. Company colour is acquired from this variable.
std::unique_ptr< ViewportData > | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus = nullptr
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings {}
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root {}
| Root of the nested tree.
WidgetLookup | widget_lookup {}
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select = nullptr
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size {}
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget = INVALID_WIDGET
| ID of current mouse capture widget (e.g. dragged scrollbar). `INVALID_WIDGET` if no widget has mouse capture.
Window * | parent = nullptr
| Parent window.
WindowList::iterator | z_position {}

## Additional Inherited Members
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
static void | DeleteClosedWindows ()
| Delete all closed windows.
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height, bool allow_resize)
| Resize window towards the default size.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data {}
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize = false
| Set if window has been resized.

## Detailed Description

Definition at line 257 of file depot_gui.cpp.

## Member Enumeration Documentation

## ◆ DepotGUIAction

enum DepotWindow::DepotGUIAction : uint8_t

Definition at line 466 of file depot_gui.cpp.

## Constructor & Destructor Documentation

## ◆ DepotWindow()

DepotWindow::DepotWindow | ( | WindowDesc & | desc,
|  | TileIndex | tile,
|  | VehicleType | type
| ) |  |
| inline

Definition at line 276 of file depot_gui.cpp.

## Member Function Documentation

## ◆ Close()

void DepotWindow::Close | ( | int | data = `0` | ) |
| inlineoverridevirtual

Hide the window and all its child windows, and mark them for a later deletion.

Reimplemented from Window.

Definition at line 298 of file depot_gui.cpp.

References Window::Close(), CloseWindowById(), GetDestinationIndex(), GetWindowClassForVehicleType(), Window::owner, OrderBackup::Reset(), VL_DEPOT_LIST, WC_BUILD_VEHICLE, and Window::window_number.

## ◆ CountDraggedLength()

uint DepotWindow::CountDraggedLength | ( | const Train * | t | ) | const
| inline

Count the dragged selection length if appropriate for the provided train.

Note
  This ignores potential changes in length due to callback returning different results.

Parameters

  t | Train being counted.

Returns
  Additional length of dragged selection to add.

Definition at line 312 of file depot_gui.cpp.

References SpecializedVehicle< T, Type >::Get(), SpecializedVehicle< T, Type >::Next(), and CursorVars::vehchain.

Referenced by DrawVehicleInDepot().

## ◆ DepotClick()

void DepotWindow::DepotClick | ( | int | x,
|  | int | y
| ) |  |
| inline

Handle click in the depot matrix.

Parameters

  x | Horizontal position in the matrix widget in pixels.
  y | Vertical position in the matrix widget in pixels.

Definition at line 571 of file depot_gui.cpp.

References _ctrl_pressed, EIT_IN_DEPOT, HT_DRAG, Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem< Tpool >::index, Window::SetDirty(), SetMouseCursorVehicle(), SetObjectToPlaceWnd(), ShowVehicleViewWindow(), SPR_CURSOR_MOUSE, StartStopVehicle(), VEH_TRAIN, CursorVars::vehchain, and VehicleClicked().

Referenced by OnClick().

## ◆ DrawVehicleInDepot()

void DepotWindow::DrawVehicleInDepot | ( | const Vehicle * | v,
|  | const Rect & | r
| ) |  | const
| inline

Draw a vehicle in the depot window in the box with the top left corner at x,y.

Parameters

  v | Vehicle to draw.
  r | Rect to draw in.

Definition at line 340 of file depot_gui.cpp.

References _consistent_train_width, _current_text_dir, Vehicle::age, GroundVehicleCache::cached_total_length, CeilDiv(), CountDraggedLength(), TimerGameConst< struct Calendar >::DAYS_IN_LEAP_YEAR, DrawAircraftImage(), DrawRoadVehImage(), DrawShipImage(), DrawString(), DrawTrainImage(), EIT_IN_DEPOT, flag_size, SpecializedVehicle< T, Type >::From(), FS_NORMAL, FS_SMALL, GroundVehicle< T, Type >::gcache, GetCharacterHeight(), Scrollbar::GetPosition(), GetString(), WidgetDimensions::hsep_normal, Rect::Indent(), GroundVehicle< T, Type >::IsFreeWagon(), Vehicle::IsGroundVehicle(), WidgetDimensions::matrix, Vehicle::max_age, SA_CENTER, SA_FORCE, SA_RIGHT, WidgetDimensions::scaled, ScaleSpriteTrad(), Rect::Shrink(), Stopped, TD_RTL, BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Test(), TILE_SIZE, Rect::Translate(), BaseVehicle::type, Vehicle::unitnumber, VEH_AIRCRAFT, VEH_ROAD, VEH_SHIP, VEH_TRAIN, vehicle_over, Vehicle::vehstatus, WidgetDimensions::vsep_normal, Rect::WithHeight(), and Rect::WithWidth().

Referenced by DrawWidget().

## ◆ DrawWidget()

void DepotWindow::DrawWidget | ( | const Rect & | r,
|  | WidgetID | widget
| ) |  | const
| inlineoverridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 396 of file depot_gui.cpp.

References _consistent_train_width, _current_text_dir, NWidgetCore::colour, NWidgetBase::current_y, DrawVehicleInDepot(), GetColourGradient(), Scrollbar::GetPosition(), Rect::Indent(), num_columns, Window::resize, NWidgetBase::resize_y, WidgetDimensions::scaled, ScaleGUITrad(), ScaleSpriteTrad(), Rect::Shrink(), ResizeInfo::step_height, ResizeInfo::step_width, TD_RTL, Rect::Translate(), VEH_TRAIN, WID_D_MATRIX, Rect::WithHeight(), and Rect::WithWidth().

## ◆ GetDestinationIndex()

DestinationID DepotWindow::GetDestinationIndex | ( |  | ) | const
| inline

Gets the DepotID of the current window.

In the case of airports, this is the station ID.

Returns
  Depot or station ID of this window.

Definition at line 1162 of file depot_gui.cpp.

References GetDepotDestinationIndex(), and Window::window_number.

Referenced by Close(), GetWidgetString(), OnClick(), and OnQueryTextFinished().

## ◆ GetVehicleFromDepotWndPt()

DepotGUIAction DepotWindow::GetVehicleFromDepotWndPt | ( | int | x,
|  | int | y,
|  | const Vehicle ** | veh,
|  | GetDepotVehiclePtData * | d
| ) |  |
| inline

Definition at line 473 of file depot_gui.cpp.

## ◆ GetWidgetString()

std::string DepotWindow::GetWidgetString | ( | WidgetID | widget,
|  | StringID | stringid
| ) |  | const
| inlineoverridevirtual

Get the raw string for a widget.

Calls to this function are also made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.
  stringid | StringID assigned to widget.

Returns
  raw string to display.

Reimplemented from Window.

Definition at line 454 of file depot_gui.cpp.

References GetDestinationIndex(), GetString(), Window::GetWidgetString(), and WID_D_CAPTION.

## ◆ OnClick()

void DepotWindow::OnClick | ( | Point | pt,
|  | WidgetID | widget,
|  | int | click_count
| ) |  |
| inlineoverridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 793 of file depot_gui.cpp.

References _ctrl_pressed, CS_ALPHANUMERAL, DepotClick(), EnableDefault, GetDestinationIndex(), GetEncodedString(), GetString(), GetTileOwner(), HT_VEHICLE, Window::IsWidgetLowered(), LengthIsInChars, MAX_LENGTH_DEPOT_NAME_CHARS, Window::owner, ResetObjectToPlace(), ScrollMainWindowToTile(), SetObjectToPlaceWnd(), Window::SetWidgetDirty(), ShowExtraViewportWindow(), ShowQuery(), ShowQueryString(), SndClickBeep(), Window::ToggleWidgetLoweredState(), VL_DEPOT_LIST, WID_D_AUTOREPLACE, WID_D_BUILD, WID_D_CLONE, WID_D_LOCATION, WID_D_MATRIX, WID_D_RENAME, WID_D_SELL_ALL, WID_D_START_ALL, WID_D_STOP_ALL, WID_D_VEHICLE_LIST, and Window::window_number.

## ◆ OnCTRLStateChange()

EventState DepotWindow::OnCTRLStateChange | ( |  | ) |
| inlineoverridevirtual

The state of the control key has changed.

Returns
  ES_HANDLED if the change has been handled and no other window should receive the event.

Reimplemented from Window.

Definition at line 1146 of file depot_gui.cpp.

References _ctrl_pressed, ES_HANDLED, ES_NOT_HANDLED, Window::SetWidgetDirty(), CursorVars::vehchain, and WID_D_MATRIX.

## ◆ OnDragDrop()

void DepotWindow::OnDragDrop | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inlineoverridevirtual

A dragged 'object' has been released.

Parameters

  pt | the point inside the window where the release took place.
  widget | the widget where the release took place.

Reimplemented from Window.

Definition at line 1070 of file depot_gui.cpp.

References _ctrl_pressed, Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_vehicle_pool >::Get(), Window::HandleButtonClick(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem< Tpool >::index, INVALID_CLIENT_ID, INVALID_WIDGET, Vehicle::IsFrontEngine(), Window::IsWidgetDisabled(), Window::SetDirty(), ShowVehicleViewWindow(), Vehicle::tile, BaseVehicle::type, VEH_TRAIN, CursorVars::vehchain, WID_D_MATRIX, WID_D_SELL, WID_D_SELL_CHAIN, Coord2D< T >::x, and Coord2D< T >::y.

## ◆ OnInit()

void DepotWindow::OnInit | ( |  | ) |
| inlineoverridevirtual

Notification that the nested widget tree gets initialized.

The event can be used to perform general computations.

Note
  nested_root and/or widget_lookup (normally accessed via GetWidget()) may not exist during this call.

Reimplemented from Window.

Definition at line 676 of file depot_gui.cpp.

References cell_size, EIT_IN_DEPOT, flag_size, GetScaledSpriteSize(), GetVehicleImageCellSize(), and maxdim().

## ◆ OnInvalidateData()

void DepotWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 727 of file depot_gui.cpp.

## ◆ OnMouseDrag()

void DepotWindow::OnMouseDrag | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inlineoverridevirtual

An 'object' is being dragged at the provided position, highlight the target if possible.

Parameters

  pt | The point inside the window that the mouse hovers over.
  widget | The widget the mouse hovers over.

Reimplemented from Window.

Definition at line 1019 of file depot_gui.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem< Tpool >::index, Vehicle::Last(), Vehicle::Previous(), Window::SetWidgetDirty(), Window::SetWidgetLoweredState(), VEH_TRAIN, WID_D_MATRIX, WID_D_SELL, WID_D_SELL_CHAIN, Coord2D< T >::x, and Coord2D< T >::y.

## ◆ OnMouseLoop()

void DepotWindow::OnMouseLoop | ( |  | ) |
| inlineoverridevirtual

Called for every mouse loop run, which is at least once per (game) tick.

Reimplemented from Window.

Definition at line 1011 of file depot_gui.cpp.

References Window::SetDirty(), and ShowCargoIconOverlay().

## ◆ OnPaint()

void DepotWindow::OnPaint | ( |  | ) |
| inlineoverridevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 745 of file depot_gui.cpp.

References _local_company, CeilDiv(), Window::DrawWidgets(), SpecializedVehicle< T, Type >::From(), Train::GetDisplayImageWidth(), GetUnitNumberDigits(), IsTileOwner(), SpecializedVehicle< T, Type >::Next(), Window::ReInit(), ScaleSpriteTrad(), Scrollbar::SetCount(), Window::SetWidgetsDisabledState(), VEH_TRAIN, WID_D_AUTOREPLACE, WID_D_BUILD, WID_D_CLONE, WID_D_RENAME, WID_D_SELL, WID_D_SELL_ALL, WID_D_SELL_CHAIN, WID_D_START_ALL, WID_D_STOP_ALL, Window::width, and Window::window_number.

## ◆ OnPlaceObjectAbort()

void DepotWindow::OnPlaceObjectAbort | ( |  | ) |
| inlineoverridevirtual

The user cancelled a tile highlight mode that has been set.

Reimplemented from Window.

Definition at line 993 of file depot_gui.cpp.

References INVALID_WIDGET, Window::RaiseWidget(), Window::SetWidgetDirty(), Window::SetWidgetLoweredState(), WID_D_CLONE, and WID_D_MATRIX.

## ◆ OnQueryTextFinished()

void DepotWindow::OnQueryTextFinished | ( | std::optional< std::string > | str | ) |
| inlineoverridevirtual

The query window opened from this window has closed.

Parameters

  str | the new value of the string, `std::nullopt` if the window was cancelled or an empty string when the default button was pressed, i.e. `str->empty()`.

Reimplemented from Window.

Definition at line 865 of file depot_gui.cpp.

References GetDestinationIndex().

## ◆ OnResize()

void DepotWindow::OnResize | ( |  | ) |
| inlineoverridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 1135 of file depot_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::resize_x, Scrollbar::SetCapacity(), Scrollbar::SetCapacityFromWidget(), VEH_TRAIN, and WID_D_MATRIX.

## ◆ OnRightClick()

bool DepotWindow::OnRightClick | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inlineoverridevirtual

A click with the right mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.

Returns
  true if the click was actually handled, i.e. do not show a tooltip if tooltip-on-right-click is enabled.

Reimplemented from Window.

Definition at line 873 of file depot_gui.cpp.

References _ctrl_pressed, _sorted_cargo_specs, Vehicle::engine_type, GetEncodedString(), GuiShowTooltips(), MakeParameters(), Vehicle::Next(), NUM_CARGO, VEH_TRAIN, and WID_D_MATRIX.

## ◆ OnTimeout()

void DepotWindow::OnTimeout | ( |  | ) |
| inlineoverridevirtual

Called when this window's timeout has been reached.

Reimplemented from Window.

Definition at line 1123 of file depot_gui.cpp.

References Window::IsWidgetDisabled(), Window::RaiseWidget(), Window::SetWidgetDirty(), WID_D_SELL, and WID_D_SELL_CHAIN.

## ◆ OnVehicleSelect() [1/2]

bool DepotWindow::OnVehicleSelect | ( | const Vehicle * | v | ) |
| inlineoverride

Clones a vehicle.

Parameters

  v | the original vehicle to clone

Returns
  Always true.

Definition at line 931 of file depot_gui.cpp.

References _ctrl_pressed, CcCloneVehicle(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem< Tpool >::index, ResetObjectToPlace(), BaseVehicle::type, and Window::window_number.

Referenced by OnVehicleSelect().

## ◆ OnVehicleSelect() [2/2]

bool DepotWindow::OnVehicleSelect | ( | VehicleList::const_iterator | begin,
|  | VehicleList::const_iterator | end
| ) |  |
| inlineoverridevirtual

Clones a vehicle from a vehicle list.

If this doesn't make sense (because not all vehicles in the list have the same orders), then it displays an error.

Returns
  This always returns true, which indicates that the contextual action handled the mouse click. Note that it's correct behaviour to always handle the click even though an error is displayed, because users aren't going to expect the default action to be performed just because they overlooked that cloning doesn't make sense.

Reimplemented from Window.

Definition at line 952 of file depot_gui.cpp.

References _ctrl_pressed, AllEqual(), Vehicle::FirstShared(), GetEncodedString(), OnVehicleSelect(), ShowErrorMessage(), VehiclesHaveSameEngineList(), VehiclesHaveSameOrderList(), and WL_INFO.

## ◆ RefreshVehicleList()

void DepotWindow::RefreshVehicleList | ( |  | ) |
| inline

Definition at line 732 of file depot_gui.cpp.

## ◆ SetupWidgetData()

void DepotWindow::SetupWidgetData | ( | VehicleType | type | ) |
| inline

Function to set up vehicle specific widgets (mainly sprites and strings).

Only use this function to if the widget is used for several vehicle types and each has different text/sprites. If the widget is only used for a single vehicle type, or the same text/sprites are used every time, use the nested widget array to initialize the widget.

Definition at line 620 of file depot_gui.cpp.

References VEH_AIRCRAFT, VEH_ROAD, VEH_SHIP, VEH_TRAIN, WID_D_AUTOREPLACE, WID_D_BUILD, WID_D_CLONE, WID_D_LOCATION, WID_D_MATRIX, WID_D_SELL, WID_D_SELL_ALL, WID_D_START_ALL, WID_D_STOP_ALL, and WID_D_VEHICLE_LIST.

## ◆ UpdateWidgetSize()

void DepotWindow::UpdateWidgetSize | ( | WidgetID | widget,
|  | Dimension & | size,
|  | const Dimension & | padding,
|  | Dimension & | fill,
|  | Dimension & | resize
| ) |  |
| inlineoverridevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  | widget | Widget number.
  [in,out] | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  [in,out] | fill | Fill step of the widget.
  [in,out] | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 682 of file depot_gui.cpp.

References cell_size, VehicleCellSize::extend_left, VehicleCellSize::extend_right, flag_size, FS_SMALL, GetParamMaxDigits(), GetParamMaxValue(), GetString(), GetStringBoundingBox(), VehicleCellSize::height, WidgetDimensions::hsep_normal, Window::resize, WidgetDimensions::scaled, ScaleSpriteTrad(), VEH_ROAD, VEH_TRAIN, WidgetDimensions::vsep_normal, and WID_D_MATRIX.

## Field Documentation

## ◆ cell_size

VehicleCellSize DepotWindow::cell_size {}

Vehicle sprite cell size.

Definition at line 273 of file depot_gui.cpp.

Referenced by OnInit(), and UpdateWidgetSize().

## ◆ check_unitnumber_digits

bool DepotWindow::check_unitnumber_digits = true

Definition at line 262 of file depot_gui.cpp.

## ◆ count_width

uint DepotWindow::count_width = 0

Width of length count, including separator.

Definition at line 270 of file depot_gui.cpp.

## ◆ flag_size

Dimension DepotWindow::flag_size {}

Size of start/stop flag.

Definition at line 272 of file depot_gui.cpp.

Referenced by DrawVehicleInDepot(), OnInit(), and UpdateWidgetSize().

## ◆ generate_list

bool DepotWindow::generate_list = true

Definition at line 261 of file depot_gui.cpp.

## ◆ header_width

uint DepotWindow::header_width = 0

Width of unit number and flag, including separator.

Definition at line 271 of file depot_gui.cpp.

## ◆ hovered_widget

WidgetID DepotWindow::hovered_widget = INVALID_WIDGET

Index of the widget being hovered during drag/drop. `INVALID_WIDGET` if no drag is in progress.

Definition at line 263 of file depot_gui.cpp.

## ◆ hscroll

Scrollbar* DepotWindow::hscroll = nullptr

Only for trains.

Definition at line 268 of file depot_gui.cpp.

## ◆ last_overlay_state

bool DepotWindow::last_overlay_state = false

Definition at line 274 of file depot_gui.cpp.

## ◆ num_columns

uint DepotWindow::num_columns = 1

Number of columns.

Definition at line 267 of file depot_gui.cpp.

Referenced by DrawWidget().

## ◆ sel

VehicleID DepotWindow::sel = VehicleID::Invalid()

Definition at line 258 of file depot_gui.cpp.

## ◆ type

VehicleType DepotWindow::type = VEH_INVALID

Definition at line 260 of file depot_gui.cpp.

## ◆ unitnumber_digits

uint DepotWindow::unitnumber_digits = 2

Definition at line 266 of file depot_gui.cpp.

## ◆ vehicle_list

VehicleList DepotWindow::vehicle_list {}

Definition at line 264 of file depot_gui.cpp.

## ◆ vehicle_over

VehicleID DepotWindow::vehicle_over = VehicleID::Invalid()

Rail vehicle over which another one is dragged, `VehicleID::Invalid()` if none.

Definition at line 259 of file depot_gui.cpp.

Referenced by DrawVehicleInDepot().

## ◆ vscroll

Scrollbar* DepotWindow::vscroll = nullptr

Definition at line 269 of file depot_gui.cpp.

## ◆ wagon_list

VehicleList DepotWindow::wagon_list {}

Definition at line 265 of file depot_gui.cpp.

The documentation for this struct was generated from the following file:

- src/depot_gui.cpp